明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 367|回复: 9

[提问] 麻烦哪位大神帮我把这个lsp从单选改为多选啊,谢谢

[复制链接]
发表于 2024-7-5 23:20 | 显示全部楼层 |阅读模式
这个lsp是我在明经上东捡西捡拼出来的,大部分程序是来自“pzweng”这位大神,我只是添加了一点东西,命令只能单选,每次只可以选择一个对象,
发表于 2024-7-6 08:02 | 显示全部楼层
(defun c:mh (/ doc e n num ss)
  (while(setq doc (vla-get-ActiveDocument (vlax-get-acad-object)))
                (vla-put-mspace doc :vlax-false)
                (setq ss (ssget '((0 . "VIEWPORT"))))
                (setq n 0 num (sslength ss))
                (while (< n num)
                        (setq e (ssname ss n))
                        (progn
                                (vla-put-mspace doc :vlax-true)
                                (vla-put-activepviewport doc (vlax-ename->vla-object e))
                                (command-s "_.ucs""v")
                                (command-s "_.PSPACE"))
                        (setq n (+ n 1))
                )
                (princ)
        )
)
回复 支持 1 反对 0

使用道具 举报

 楼主| 发表于 2024-7-5 23:24 | 显示全部楼层
点错了,怎么就发布了啊
下面就是源码,麻烦哪位大神帮我修改一下
(defun c:mh (/ e doc)
  (while(setq doc (vla-get-ActiveDocument (vlax-get-acad-object)))
  (vla-put-mspace doc :vlax-false)
  (if (and (setq e (car (entsel "\n选取视口进入模型空间或<返回图纸空间>: "))) (= "VIEWPORT" (cdr (assoc 0 (entget e))))

)
    (progn
      (vla-put-mspace doc :vlax-true)
      (vla-put-activepviewport doc (vlax-ename->vla-object e))
      (command-s "_.ucs""v")
  (command-s "_.PSPACE"))
  )
  (princ)
)
  )

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有账号?注册

x
发表于 2024-7-6 08:24 | 显示全部楼层
这是什么功能呀,能介绍一下吗
发表于 2024-7-6 08:31 | 显示全部楼层
paulpipi 发表于 2024-7-6 08:24
这是什么功能呀,能介绍一下吗

(command-s "_.ucs""v")
  (command-s "_.PSPACE"))
这个功能,你的金牌会员是混上去的?
 楼主| 发表于 2024-7-6 08:41 | 显示全部楼层
cghdy 发表于 2024-7-6 08:02
(defun c:mh (/ doc e n num ss)
  (while(setq doc (vla-get-ActiveDocument (vlax-get-acad-object)))
...

好用啊,感谢大神,东西贼好使
 楼主| 发表于 2024-7-6 08:42 | 显示全部楼层
paulpipi 发表于 2024-7-6 08:24
这是什么功能呀,能介绍一下吗

就是一个功能,不用点进视口,使用ucs+v,然后在退出来
发表于 2024-7-6 10:12 | 显示全部楼层
MZ_li 发表于 2024-7-6 08:31
(command-s "_.ucs""v")
  (command-s "_.PSPACE"))
这个功能,你的金牌会员是混上去的?

我也在混,我嘎嘎水经验
发表于 2024-7-6 17:17 | 显示全部楼层
直接修改视口坐标系不就好了...不过不知道lisp有没有提供vla函数
 楼主| 发表于 2024-7-6 17:21 | 显示全部楼层
你有种再说一遍 发表于 2024-7-6 17:17
直接修改视口坐标系不就好了...不过不知道lisp有没有提供vla函数

哈哈,我用的一个插件批量生成的视口,光标不是正的,所以才想着用这个方法
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-7-13 04:54 , Processed in 0.250024 second(s), 26 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表